# -*- coding: utf8 -*-

import urllib2, urllib, time, string, sys, re, csv
import htmlparser, curvas

import mod_mysql, infoauth
dbusr, dbclv = infoauth.load("/home/facundo/roundup/infodb")
bdd = mod_mysql.DataBase("localhost", dbusr, dbclv, "roundup")

FADAPT = { 19 : "%Y-%m-%d.%H:%M:%S",
           18 : "%Y-%m-%d%H:%M:%S",
         }
FFECHA = "%Y-%m-%d"
NOPRE = re.compile("<pre>.*?</pre>", re.S)
ANCHOT = 300
URLBASE = "http://bugs.python.org/issue%d"
CANTPAG = 100

class MakeHTML(object):
    def __init__(self, lineas):
        self._rows = lineas

    def _calculoFechas(self):
        # calculamos los valores desde y hasta
        oldest_fecha = last_fecha = None
        for row in self._rows:
#            print row
            (abr_by, abr_when, ult_by, ult_when) = row[2:6]
            if oldest_fecha is None or abr_when < oldest_fecha:
                oldest_fecha = abr_when
                oldest_quien = abr_by
            if last_fecha is None or ult_when > last_fecha:
                last_fecha = ult_when
                last_quien = ult_by

        self.desde = time.mktime(time.strptime(oldest_fecha, FFECHA))
        hasta = time.mktime(time.strptime(last_fecha, FFECHA)) + 1
        delta = hasta-self.desde
        self.paso = ANCHOT/delta
        return (oldest_fecha, oldest_quien, last_fecha, last_quien)

    def _armaConteo(self, puntos):
        # contamos cuantos hay por dia
        conteo = {}
        for p in puntos:
            if p >= ANCHOT:
                raise ValueError("Recibi un punto (%d) fuera de escala (%d)" % (p, ANCHOT))
            conteo[p] = conteo.get(p, 0) + 1
        puntos = sorted(conteo.items())
        if id == "588756":
            print puntos

        base = ["f"]*ANCHOT
        for i in range(puntos[0][0], puntos[-1][0]):
            base[i] = "b"

        for pos,ancho in puntos:
            while pos<ANCHOT and base[pos] == "m":
                pos += 1
            for i in range(ancho):
                if pos+i < ANCHOT:
                    base[pos+i] = "m"

        ini = 0
        pos = 1
        ant = base[0]
        marcas = []
        while pos < ANCHOT:
            if base[pos] != ant:
                marcas.append((ant, pos-ini))
                ant = base[pos]
                ini = pos
            pos += 1

        marcas.append((ant, pos-ini))
        return marcas

    def _getSuperTabla(self, p_ini, p_fin):
        filas = []
        for row in self._rows[p_ini:p_fin]:
#            print "Cargando: ", row
            (elemid, summary, abr_by, abr_when, ult_by, ult_when, activs, prio, sevr, vers, kwds) = row

            # arrancamos la fila
            fila = ' <tr>\n'
            fila += '  <td><a href="%s">%s</a></td>\n' % (URLBASE%elemid, elemid)
            fila += '  <td>%s</td>\n' % summary
            fila += '  <td>%s</td>\n' % (prio or "&nbsp;")
            fila += '  <td>%s</td>\n' % (sevr or "&nbsp;")
            fila += '  <td>%s</td>\n' % (vers or "&nbsp;")
            fila += '  <td>%s</td>\n' % (kwds or "&nbsp;")
            fila += '  <td>%s <i>(%s)</i></td>\n' % (abr_by, abr_when)

            # hacemos anchas las marcas en funcion de la cantidad en el mismo dia
            activs = (int(x) for x in activs.split(", "))
            puntos = [int((x-self.desde) * self.paso) for x in activs]
            marcas = self._armaConteo(puntos)
            fila += '  <td>'
            for marc,ancho in marcas:
                fila += '<img src="/%s.png" width="%d" alt="">' % (marc, ancho)
            fila += '  </td>'

            # cerramos la fila
            if abr_by == ult_by and abr_when == ult_when:
                fila += '  <td>-</td>\n'
            else:
                fila += '  <td>%s <i>(%s)</i></td>\n' % (ult_by, ult_when)
            fila += ' </tr>\n'
            filas.append(fila)
        return "\n".join(filas)

    def _paginador(self):
        p_ini = 0
        pag = -1
        cant = len(self._rows)
        for pag, p_fin in enumerate(range(CANTPAG-1, cant, CANTPAG)):
            yield (p_ini, p_fin, pag)
            p_ini = p_fin + 1
        if p_ini == cant:
            return
        yield (p_ini, cant, pag+1)

    def _getInfoPaginado(self, estapag, query):
        if estapag is None:
            estapag = 0
        else:
            estapag = int(estapag)
        filas = []
        valido = False
        for (p_ini, p_fin, pag) in self._paginador():
            # el ini y fin están cruzados porque el órden de la tabla es
            # descendente en sus IDs
            item_fin = self._rows[p_ini][0]
            item_ini = self._rows[p_fin-1][0]
            texto = "%s<br>to<br>%s" % (item_ini, item_fin)
            if pag != estapag:
                conector = (query[-1] != "?") and "&" or ""
                texto = '<a href="%s%snropag=%d">%s</a>' % (query, conector, pag, texto)
            else:
                item_desde = item_ini
                item_hasta = item_fin
                posic_ini = p_ini
                posic_fin = p_fin
                valido = True
            campo = '    <td align="center">%s</td>' % texto
            filas.append(campo)
        if not valido:
            item_desde = item_ini
            item_hasta = item_fin
            posic_ini = p_ini
            posic_fin = p_fin
        return ("\n".join(filas), posic_ini, posic_fin, item_desde, item_hasta)

    def generaFinalDoc(self, nropag, query, updated):
        if self._rows:
            # paginamos
            (oldest_fecha, oldest_quien, last_fecha, last_quien) = self._calculoFechas()
            (paginado_links, p_ini, p_fin, item_desde, item_hasta) = self._getInfoPaginado(nropag, query)
            registros_tabla = self._getSuperTabla(p_ini, p_fin)
        else:
            oldest_quien = last_quien = item_desde = item_hasta = paginado_links = "-"
            oldest_fecha = last_fecha = paginado_links = registros_tabla = ""

        cant_registros = len(self._rows)
        ancho_total = "%dpx" % (ANCHOT + 2)
        updated = time.ctime(updated)

        # cargamos el template
        arch = open("/home/facundo/roundup/resumen.template")
        template = string.Template(arch.read())
        html = template.substitute(locals())
        return html

def _armaURLparc(**vals):
    d = dict((k,v) for k,v in vals.items() if v is not None)
    return urllib.urlencode(d)



def getInfo(updated, nropag=0, version=None, keyword=None, priority=None, severity=None):
    # las que cruzan
    qfrom = "items"
    qwhere = ""
    if version is not None:
        qfrom = " (%s) inner join item_versions using (elemid)" % qfrom
        qwhere += " and item_versions.cod=%d" % int(version)
    if keyword is not None:
        qfrom = " (%s) inner join item_keywords using (elemid)" % qfrom
        qwhere += " and item_keywords.cod=%d" % int(keyword)
    qfrom = " (%s) inner join priority on (items.priority=priority.kw)" % qfrom
    qfrom = " (%s) inner join severity on (items.severity=severity.kw)" % qfrom

    # las que filtran
    if priority is not None:
        qwhere += " and priority=%d" % int(priority)
    if severity is not None:
        qwhere += " and severity=%d" % int(severity)

    # sanitizamos qfrom y qwhere
    while "(items)" in qfrom:
        qfrom = qfrom.replace("(items)", "items")
    qwhere = qwhere[5:]

    # armamos
    # elemid, title, creat_by, creat_dt, lastc_by, lastc_dt, priority, severity, versions, keywords
    qbase = "select items.elemid, title, creat_by, creat_dt, lastc_by, lastc_dt, activs, priority.descrip, severity.descrip, all_versions, all_keywords from"
    if qwhere:
        query = "%s %s where %s order by creat_dt desc;" % (qbase, qfrom, qwhere)
    else:
        query = "%s %s order by creat_dt desc;" % (qbase, qfrom)
#    print "qqq- ", query

    # armamos el documento
    lineas = bdd.accion(query)
    html = MakeHTML(lineas)

    urlparc = "/cgi-bin/pytickets.py?" + _armaURLparc(
                version=version, keyword=keyword, priority=priority, severity=severity)
    result = html.generaFinalDoc(nropag, urlparc, updated)
    return result

if __name__ == "__main__":
    ini = time.time()
#    getInfo(version=12, priority=4)
    getInfo(1, version=12)
    print "tiempo:", (time.time()-ini)
